﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataGridCellBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<DataItem> collection = new ObservableCollection<DataItem>();
            collection.Add(new DataItem() { Salary = 2225.50, CanEditSalary = false });
            collection.Add(new DataItem() { Salary = 2225.50, CanEditSalary = true });
            collection.Add(new DataItem() { Salary = 2225.50, CanEditSalary = false });
            collection.Add(new DataItem() { Salary = 2225.50, CanEditSalary = true });
            collection.Add(new DataItem() { Salary = 2225.50, CanEditSalary = false });

            DataContext = collection;
        }
    }

   

    public class DataItem : INotifyPropertyChanged
    {
        private bool _canEditSalary;
        private double _salary;

        public double Salary 
        {
            get
            {
                return _salary;
            }
            set
            {
                if (_salary != value)
                {
                    _salary = value;
                    OnPropertyChanged("Salary");
                }
            }

        }

        public bool CanEditSalary
        {
            get
            {
                return _canEditSalary;
            }
            set
            {
                if (_canEditSalary != value)
                {
                    _canEditSalary = value;
                    OnPropertyChanged("CanEditSalary");
                }
            }
        }
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }

}
